package com.zh.project0512.mapper;

import com.zh.project0512.model.QywxDepartmentGroupLink;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-06-24
 */
public interface QywxDepartmentGroupLinkMapper extends BaseMapper<QywxDepartmentGroupLink> {
    @Insert("<script> " +
        "insert into qywxDepartmentGroupLink (groupId,departmentId,creatAt) values\n"+
        "  <foreach collection= 'departmentIdList' item= 'item'  separator=','>\n" +
        "(#{groupId},#{item},#{creatAt})\n"+
        "</foreach> \n"+
        "</script>")
    void groupAddDepartment(Integer groupId, List<Integer> departmentIdList, LocalDateTime creatAt);
    List<Map> departmentList(Integer groupId);
    @Select("    SELECT t1.departmentId,t1.creatAt,t3.name as departmentName\n" +
        "    ,t4.id as userId,t4.name as userName\n" +
        "    from qywxDepartmentGroupLink as t1\n" +
        "    LEFT JOIN qywxDepartmentGroup as t2 on t1.groupId = t2.id\n" +
        "    INNER JOIN qywxDepartment as t3 on t3.departmentId = t1.departmentId\n" +
        "    INNER JOIN user as t4 on t4.main_department = t1.departmentId\n" +
        "    where t2.id = #{groupId} \n" +
        "    GROUP BY userName\n" +
        "    ORDER BY creatAt DESC")
    List<Map> departmentList2(Integer groupId);
    @Select("<script> "+
        "SELECT t1.departmentId\n" +
        "from qywxDepartmentGroupLink as t1\n" +
        "LEFT JOIN qywxDepartmentGroup as t2 on t1.groupId = t2.id\n" +
        "INNER JOIN qywxDepartment as t3 on t3.departmentId = t1.departmentId \n" +
        "where t2.id in \n" +
        "<foreach collection='groupIdList' index='index' item='item' open='(' separator=',' close=')'>" +
        "#{item}" +
        "</foreach>" +
        "GROUP BY departmentId" +
        "</script>")
    List<Integer> departmentIdList(Integer xxx, List<Integer> groupIdList);
}
