package com.zh.project0512.serviceImpl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.project0512.model.User;
import com.zh.project0512.model.Video;
import com.zh.project0512.mapper.VideoMapper;
import com.zh.project0512.service.IVideoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zh
 * @since 2022-05-18
 */
@Service
public class VideoServiceImpl extends ServiceImpl<VideoMapper, Video> implements IVideoService {
    @Autowired
    private VideoMapper videoMapper;

    public void updStatusWhenTaskEnd(String now) {
        videoMapper.updStatusWhenTaskEnd(now);
    }

    public void updStatusByTaskId(int taskId, LocalDateTime localDateTime){
        videoMapper.updStatusByTaskId(taskId, localDateTime);
    }

    public IPage<Map> pageList(IPage iPage, @Param("ew") Wrapper<Video> queryWrapper) {
        return videoMapper.pageList(iPage, queryWrapper);
    }

    public JSONObject record(String openid) {
        return videoMapper.record(openid);
    }
    public List<Map> videoEffectResult(int taskId){
        return  videoMapper.videoEffectResult(taskId);
    }
    public List<Map> videoDataByUserTask(@Param("ew") Wrapper<Video> queryWrapper){
        return  videoMapper.videoDataByUserTask(queryWrapper);
    }
}
