package com.zh.project0512.utils;


import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.poi.hssf.usermodel.HSSFDateUtil;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class ExcelUtil {

    public static Workbook writeToExcelByList(String[][] array, List<Map> list) {
        //创建工作薄
        Workbook wb = new XSSFWorkbook();
        //标题和页码
        CellStyle titleStyle = wb.createCellStyle();
        // 设置单元格对齐方式,水平居左
        titleStyle.setAlignment(HorizontalAlignment.LEFT);
        // 设置字体样式
        Font titleFont = wb.createFont();
        // 字体高度
        titleFont.setFontHeightInPoints((short) 12);
        // 字体样式
        titleFont.setFontName("黑体");
        titleStyle.setFont(titleFont);
        //创建sheet
        Sheet sheet = wb.createSheet("接入详情");
        // 自动设置宽度
        sheet.autoSizeColumn(0);
        // 在sheet中添加标题行// 行数从0开始
        Row row = sheet.createRow((int) 0);
        String[] titleArray = array[0];
        for (int i = 0; i < titleArray.length; i++) {
            Cell cell = row.createCell(i);
            cell.setCellValue(titleArray[i]);
            cell.setCellStyle(titleStyle);
        }
        // 数据样式 因为标题和数据样式不同 需要分开设置 不然会覆盖
        CellStyle dataStyle = wb.createCellStyle();
        // 设置居中样式，水平居中
        dataStyle.setAlignment(HorizontalAlignment.CENTER);
        String[] valueArray = array[1];
        String[] formatArray = array[2];
        //数据从序号1开始
        try {
            int index = 1;
            for (Map value : list) {
                // 默认的行数从0开始，为了统一格式设置从1开始，就是从excel的第二行开始
                row = sheet.createRow(index);
                index++;
                Map data = value;
                for (int i = 0; i < valueArray.length; i++) {
                    Cell cell = row.createCell(i);
                    if (formatArray[i] == "String") {
                        cell.setCellValue((String) value.get(valueArray[i]));
                    } else if (formatArray[i] == "LocalDateTime") {
                        cell.setCellValue(value.get(valueArray[i])==null?null:value.get(valueArray[i]).toString());
                    } else if (formatArray[i] == "int") {
                        cell.setCellValue(Integer.parseInt(String.valueOf(value.get(valueArray[i]))));
                    }
                    cell.setCellStyle(dataStyle);
                }
//                for (int j = 0; j < data.size(); j++) {
//                    Cell cell = row.createCell(j);
//                    // 为当前列赋值
//                    cell.setCellValue(data.get(j).toString());
//                    //设置数据的样式
//                    cell.setCellStyle(dataStyle);
//                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return wb;
    }

}
